#!/usr/bin/env python
# coding: utf-8

# * Linear

# In[15]:


import numpy as np
import matplotlib.pyplot as plt
n=7
l=1
V1=4;V2=0

d=l/(n-1)
rho=10**(-9)
epsilon=8.85*10**(-12)
k=1*epsilon/d
b=d*rho/2

K=np.zeros([n,n])
B=np.zeros([n,1])
i=1
while i < n-1:
    K[i][i-1]=-1*k;K[i][i]=2*k;K[i][i+1]=-1*k;B[i][0]=2*b
    i=i+1
K[0][0]=1;B[0][0]=V1
K[n-1][n-1]=1;B[n-1][0]=V2
X=np.linspace(0,l,n)
Y=np.dot(np.linalg.inv(K),B).reshape(-1)
X2=np.linspace(0,l,n*10)
Y2=[-rho*x**2/(2*epsilon)-(-rho*l/(2*epsilon)+(V1-V2)/l)*x+V1 for x in X2]
plt.plot(X,Y,marker='o')
plt.plot(X2,Y2)
plt.show()


# * Quadratic

# In[14]:


import numpy as np
import matplotlib.pyplot as plt
n=7  #奇数
l=1
V1=4;V2=0

d=2*l/(n-1)
rho=10**(-9)
epsilon=8.85*10**(-12)
k=1*epsilon/(3*d)
b=d*rho/6

K=np.zeros([n,n])
B=np.zeros([n,1])
for i in range(1,n-1,2):
    K[i][i-1]=-8*k;K[i][i]=16*k;K[i][i+1]=-8*k;B[i][0]=4*b
for i in range(2,n-1,2):
    K[i][i-2]=1*k;K[i][i-1]=-8*k;K[i][i]=14*k;K[i][i+1]=-8*k;K[i][i+2]=1*k;B[i][0]=2*b
K[0][0]=1;B[0][0]=V1
K[n-1][n-1]=1;B[n-1][0]=V2
X=np.linspace(0,l,n)
Y=np.dot(np.linalg.inv(K),B).reshape(-1)
X2=np.linspace(0,l,n*10)
Y2=[-rho*x**2/(2*epsilon)-(-rho*l/(2*epsilon)+(V1-V2)/l)*x+V1 for x in X2]
plt.plot(X,Y,marker='o')
plt.plot(X2,Y2)
plt.show()


# * Cubic

# In[2]:


import numpy as np
import matplotlib.pyplot as plt
n=16  #3的倍数+1
l=1
V1=4;V2=0

d=3*l/(n-1)
rho=10**(-9)
epsilon=8.85*10**(-12)
k=1*epsilon/(40*d)
b=d*rho/8

K=np.zeros([n,n])
B=np.zeros([n,1])
for i in range(1,n-1,3):
    K[i][i-1]=-189*k;K[i][i]=432*k;K[i][i+1]=-297*k;K[i][i+2]=54*k;B[i][0]=3*b
for i in range(2,n-1,3):
    K[i][i-2]=54*k;K[i][i-1]=-297*k;K[i][i]=432*k;K[i][i+1]=-189*k;B[i][0]=3*b
for i in range(3,n-1,3):
    K[i][i-3]=-13*k;K[i][i-2]=54*k;K[i][i-1]=-189*k;K[i][i]=296*k;K[i][i+1]=-189*k;K[i][i+2]=54*k;K[i][i+3]=-13*k;B[i][0]=2*b
K[0][0]=1;B[0][0]=V1
K[n-1][n-1]=1;B[n-1][0]=V2
X=np.linspace(0,l,n)
Y=np.dot(np.linalg.inv(K),B).reshape(-1)
X2=np.linspace(0,l,n*10)
Y2=[-rho*x**2/(2*epsilon)-(-rho*l/(2*epsilon)+(V1-V2)/l)*x+V1 for x in X2]
plt.plot(X,Y,marker='o')
plt.plot(X2,Y2)
plt.show()


# 采样问题
# 收敛情况
# 网格划分、粗细
# 圆的形状：三角形

# * 电荷分布
# * 点电荷的奇点
# * 无限元域（边界）
# * 混合边界条件：电势、电场、电荷密度
# * 非线性介质（最简单的）（空间的函数or电场的函数）
# * 电场能
# * 加权函数/差值函数

# In[ ]:




